
var LOGFILE_NAME = "emails.log";
var l = new Logger(LOGFILE_NAME);

function getDefaulMailObject()
{
	var oParameter={};
	oParameter.email_server="";
	oParameter.login="";
	oParameter.password="";
	oParameter.sender="";
	oParameter.receiver="";
	oParameter.subject="";
	oParameter.body="";
	
	var prop = Property.getNode('/config/credentials/mail/mailserver');
	if (prop)
		oParameter.email_server=prop.getValue();
	prop = Property.getNode('/config/credentials/mail/login');
	if (prop)
		oParameter.login=prop.getValue();
	prop = Property.getNode('/config/credentials/mail/password');
	if (prop)
		oParameter.password=prop.getValue();
	prop = Property.getNode('/config/credentials/mail/sender');
	if (prop)
		oParameter.sender=prop.getValue();
	prop = Property.getNode('/config/credentials/mail/receiver');
	if (prop)
		oParameter.receiver=prop.getValue();

	return oParameter;
}

function sendMailOrDie(oParameter)
{
	var fDie=false;
	var errorMessage="";
	if (oParameter.email_server=="") {
		errorMessage+=" - Kein Email-Versende Server angegeben\n";
		fDie=true;
	}
	if (oParameter.login=="") {
		errorMessage+=" - Kein Loginname fuer Versendeserver angegeben\n";
		fDie=true;
	}
	if (oParameter.password=="") {
		errorMessage+=" - Kein Passwort fuer Versendeserver angegeben\n";
		fDie=true;
	}
	if (oParameter.sender=="") {
		errorMessage+=" - Kein Absender angegeben\n";
		fDie=true;
	}
	if (oParameter.receiver=="") {
		errorMessage+=" - Kein Empfaenger angegeben\n";
		fDie=true;
	}
	if (fDie)
	{
		l.logln("Email: Beim Versenden einer Email sind folgende Fehler aufgetreten "+
				"(und deswegen wurde die Email auch nicht weiter losgeschickt) \n" +errorMessage);
	} else {
		var evt = new Event("aizo-email-forwardEmail",oParameter);
		evt.raise();
	}
}

function sendMail(baseNode)
{
	var mailParamNodes = baseNode.getChild('mailParams')
	
	var oParameter=getDefaulMailObject();

	var prop = mailParamNodes.getChild('mailserver');
	if (prop)
		oParameter.email_server=prop.getValue();
	prop = mailParamNodes.getChild('login');
	if (prop)
		oParameter.login=prop.getValue();
	prop = mailParamNodes.getChild('password');
	if (prop)
		oParameter.password=prop.getValue();
	prop = mailParamNodes.getChild('sender');
	if (prop)
		oParameter.sender=prop.getValue();

	prop = mailParamNodes.getChild('receiver');
	if (prop)
		oParameter.receiver=prop.getValue();

	prop = mailParamNodes.getChild('subject');
	if (prop)
		oParameter.subject=prop.getValue();
	
	prop = mailParamNodes.getChild('body');
	if (prop)
		oParameter.body=prop.getValue();
	
	sendMailOrDie(oParameter);

}

function main() 
{ 
	if (raisedEvent.name=="aizo-email-forward")
	{
		if (raisedEvent.parameter.actions) {
			if (raisedEvent.parameter.actions=='load')
				Property.load();
			if (raisedEvent.parameter.actions=='save')
				Property.store();	
		}
	} else if (raisedEvent.name=="callScene") 
	{
		var zone=raisedEvent.source.zoneID;
		var group=raisedEvent.source.groupID;
		var scene=raisedEvent.parameter.sceneID;
				
		if (zone==null)
			return;
		if (group==null)
			return;
		if (scene==null)
			return;
		
		Property.load();
		var sendingProperty=Property.getNode('sending');
		if (sendingProperty) {
			var sendingSubProp=sendingProperty.getChildren();
			for (var iIndex=0;iIndex<sendingSubProp.length;iIndex++)
			{

				var baseProp=sendingSubProp[iIndex];
				var fBreak=false;
				if (baseProp.getChild('disabled'))
					if (baseProp.getChild('disabled')==true)
						fBreak=true;

				if (!fBreak) {
					var triggerProp=baseProp.getChild('trigger');
					if (triggerProp)
					{
						var triggerZone=triggerProp.getChild('zone');
						var triggerGroup=triggerProp.getChild('group');
						var triggerScene=triggerProp.getChild('scene');
						if (triggerZone!=null)
							if (triggerGroup!=null)
								if (triggerScene!=null)
									if (triggerZone.getValue()==zone)
										if (triggerGroup.getValue()==group)
											if (triggerScene.getValue()==scene) 
											{
												l.logln("Email: found matching subscription");
												sendMail(baseProp);
											}
					}
				}
			}
		}
	}
}

main();

